Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## com.trolltech.qt.gui
Class QMatrix

    java.lang.Object
      com.trolltech.qt.internal.QSignalEmitterInternal
          com.trolltech.qt.QSignalEmitter
              com.trolltech.qt.QtJambiObject
                  com.trolltech.qt.gui.QMatrix

All Implemented Interfaces:
  QtJambiInterface, java.lang.Cloneable

    public class QMatrix

extends QtJambiObject
implements java.lang.Cloneable

The `QMatrix` class specifies 2D transformations of a coordinate system. A matrix specifies how to translate, scale, shear or rotate the coordinate system, and is typically used when rendering graphics.

A `QMatrix` object can be built using the `setMatrix()`, `scale()`, `rotate()`, `translate()` and `shear()` functions. Alternatively, it can be built by applying `basic matrix operations`. The matrix can also be defined when constructed, and it can be reset to the identity matrix (the default) using the `reset()` function.

The `QMatrix` class supports mapping of graphic primitives: A given point, line, polygon, region, or painter path can be mapped to the coordinate system defined by this matrix using the `map()` function. In case of a rectangle, its coordinates can be transformed using the `mapRect()` function. A rectangle can also be transformed into a polygon (mapped to the coordinate system defined by this matrix), using the `mapToPolygon()` function.

`QMatrix` provides the `isIdentity()` function which returns true if the matrix is the identity matrix, and the `isInvertible()` function which returns true if the matrix is non-singular (i.e. AB = BA = I). The `inverted()` function returns an inverted copy of this matrix if it is invertible (otherwise it returns the identity matrix). In addition, `QMatrix` provides the `det()` function returning the matrix's determinant.

Finally, the `QMatrix` class supports matrix multiplication, and objects of the class can be streamed as well as compared.

- Rendering Graphics
- Basic Matrix Operations

## Rendering Graphics

When rendering graphics, the matrix defines the transformations but the actual transformation is performed by the drawing routines in `QPainter`.

By default, `QPainter` operates on the associated device's own coordinate system. The standard coordinate system of a `QPaintDevice` has its origin located at the top-left position. The x values increase to the right; y values increase downward. For a complete description, see the coordinate system documentation.

`QPainter` has functions to translate, scale, shear and rotate the coordinate system without using a `QMatrix`. For example:

        protected void paintEvent(QPaintEvent event)
        {
            QPainter painter = new QPainter(this);
            painter.setPen(new QPen(QColor.blue, 1, Qt.PenStyle.DashLine));
            painter.drawRect(0, 0, 100, 100);

            painter.rotate(45);

            painter.setFont(new QFont("Helvetica", 24));
            painter.setPen(new QPen(QColor.black, 1));
            painter.drawText(20, 10, "QMatrix");
        }

Although these functions are very convenient, it can be more efficient to build a `QMatrix` and call QPainter::setMatrix() if you want to perform more than a single transform operation. For example:

        protected void paintEvent(QPaintEvent event)
        {
            QPainter painter = new QPainter(this);
            painter.setPen(new QPen(QColor.blue, 1,
                                    Qt.PenStyle.DashLine));
            painter.drawRect(0, 0, 100, 100);

            QMatrix matrix = new QMatrix();
            matrix.translate(50, 50);
            matrix.rotate(45);
            matrix.scale(0.5, 1.0);
            painter.setWorldMatrix(matrix);

            painter.setFont(new QFont("Helvetica", 24));
            painter.setPen(new QPen(QColor.black, 1));
            painter.drawText(20, 10, "QMatrix");
        }

## Basic Matrix Operations

A `QMatrix` object contains a 3 x 3 matrix. The `dx` and `dy` elements specify horizontal and vertical translation. The `m11` and `m22` elements specify horizontal and vertical scaling. And finally, the `m21` and `m12` elements specify horizontal and vertical shearing.

`QMatrix` transforms a point in the plane to another point using the following formulas:

            x' = m11 + m21 + dx
            y' = m22 + m12 + dy

The point (x, y) is the original point, and (x', y') is the transformed point. (x', y') can be transformed back to (x, y) by performing the same operation on the `inverted()` matrix.

The various matrix elements can be set when constructing the matrix, or by using the `setMatrix()` function later on. They also be manipulated using the `translate()`, `rotate()`, `scale()` and `shear()` convenience functions, The currently set values can be retrieved using the `m11()`, `m12()`, `m21()`, `m22()`, `dx()` and `dy()` functions.

Translation is the simplest transformation. Setting `dx` and `dy` will move the coordinate system `dx` units along the X axis and `dy` units along the Y axis. Scaling can be done by setting `m11` and `m22`. For example, setting `m11` to 2 and `m22` to 1.5 will double the height and increase the width by 50%. The identity matrix has `m11` and `m22` set to 1 (all others are set to 0) mapping a point to itself. Shearing is controlled by `m12` and `m21`. Setting these elements to values different from zero will twist the coordinate system. Rotation is achieved by carefully setting both the shearing factors and the scaling factors.

Here's the combined transformations example using basic matrix operations:

        protected void paintEvent(QPaintEvent event)
        {
            double pi = 3.14;

            double a    = pi/180 * 45.0;
            double sina = Math.sin(a);
            double cosa = Math.cos(a);

            QMatrix translationMatrix = new QMatrix(1, 0, 0, 1, 50.0, 50.0);
            QMatrix rotationMatrix = new QMatrix(cosa, sina, -sina, cosa, 0, 0);
            QMatrix scalingMatrix = new QMatrix(0.5, 0, 0, 1.0, 0, 0);

            QMatrix matrix = new QMatrix();
            matrix =  scalingMatrix.multiply(rotationMatrix.multiply(translationMatrix));

            QPainter painter = new QPainter(this);
            painter.setPen(new QPen(QColor.blue, 1, Qt.PenStyle.DashLine));
            painter.drawRect(0, 0, 100, 100);

            painter.setWorldMatrix(matrix);

            painter.setFont(new QFont("Helvetica", 24));
            painter.setPen(new QPen(QColor.black, 1));
            painter.drawText(20, 10, "QMatrix");
        }

See also:
  `QPainter`, The Coordinate System, Affine Transformations Demo, and Transformations Example.

Nested Class Summary

Nested classes/interfaces inherited from class com.trolltech.qt.QSignalEmitter
`QSignalEmitter.AbstractSignal, QSignalEmitter.Signal0, QSignalEmitter.Signal1, QSignalEmitter.Signal2, QSignalEmitter.Signal3, QSignalEmitter.Signal4, QSignalEmitter.Signal5, QSignalEmitter.Signal6, QSignalEmitter.Signal7, QSignalEmitter.Signal8, QSignalEmitter.Signal9`

Nested classes/interfaces inherited from class com.trolltech.qt.internal.QSignalEmitterInternal
`com.trolltech.qt.internal.QSignalEmitterInternal.AbstractSignalInternal`

Field Summary

Fields inherited from class com.trolltech.qt.internal.QSignalEmitterInternal
`currentSender`

Constructor Summary
`QMatrix()` Constructs an identity matrix.
`QMatrix(double m11, double m12, double m21, double m22, double dx, double dy)` Constructs a matrix with the elements, `m11`, `m12`, `m21`, `m22`, `dx` and `dy`.
`QMatrix(QMatrix matrix)` Constructs a matrix that is a copy of the given `matrix`.

Method Summary
`QMatrix` | `clone()`
`double` | `det()` Returns the matrix's determinant.
`double` | `dx()` Returns the horizontal translation factor.
`double` | `dy()` Returns the vertical translation factor.
`QMatrix` | `inverted()` Returns an inverted copy of this matrix.
`boolean` | `isIdentity()` Returns true if the matrix is the identity matrix, otherwise returns false.
`boolean` | `isInvertible()` Returns true if the matrix is invertible, otherwise returns false.
`double` | `m11()` Returns the horizontal scaling factor.
`double` | `m12()` Returns the vertical shearing factor.
`double` | `m21()` Returns the horizontal shearing factor.
`double` | `m22()` Returns the vertical scaling factor.
`QLine` | `map(QLine l)` Creates and returns a `QLine` object that is a copy of the given `line`, mapped into the coordinate system defined by this matrix.
`QLineF` | `map(QLineF l)` Creates and returns a `QLineF` object that is a copy of the given `line`, mapped into the coordinate system defined by this matrix.
`QPainterPath` | `map(QPainterPath p)` Creates and returns a `QPainterPath` object that is a copy of the given `path`, mapped into the coordinate system defined by this matrix.
`QPoint` | `map(QPoint p)` Creates and returns a `QPoint` object that is a copy of the given `point`, mapped into the coordinate system defined by this matrix.
`QPointF` | `map(QPointF p)` Creates and returns a `QPointF` object that is a copy of the given `point`, mapped into the coordinate system defined by this matrix.
`QPolygon` | `map(QPolygon a)` Creates and returns a `QPolygon` object that is a copy of the given `polygon`, mapped into the coordinate system defined by this matrix.
`QPolygonF` | `map(QPolygonF a)` Creates and returns a `QPolygonF` object that is a copy of the given `polygon`, mapped into the coordinate system defined by this matrix.
`QRegion` | `map(QRegion r)` Creates and returns a `QRegion` object that is a copy of the given `region`, mapped into the coordinate system defined by this matrix.
`QRect` | `mapRect(QRect arg__1)` Creates and returns a `QRect` object that is a copy of the given `rectangle`, mapped into the coordinate system defined by this matrix.
`QRectF` | `mapRect(QRectF arg__1)` Creates and returns a `QRectF` object that is a copy of the given `rectangle`, mapped into the coordinate system defined by this matrix.
`QPolygon` | `mapToPolygon(QRect r)` Creates and returns a `QPolygon` representation of the given `rectangle`, mapped into the coordinate system defined by this matrix.
`QMatrix` | `multiplied(QMatrix other)`
`QMatrix` | `multiply(QMatrix other)`
`void` | `readFrom(QDataStream arg__1)` Reads a QMatrix
`void` | `reset()` Resets the matrix to an identity matrix, i.
`QMatrix` | `rotate(double other)` Rotates the coordinate system the given `other` degrees counterclockwise.
`QMatrix` | `scale(double sx, double sy)` Scales the coordinate system by `sx` horizontally and `sy` vertically, and returns a reference to the matrix.
`void` | `setMatrix(double m11, double m12, double m21, double m22, double dx, double dy)` Sets the matrix elements to the specified values, `m11`, `m12`, `m21`, `m22`, `dx` and `dy`.
`QMatrix` | `shear(double sh, double sv)` Shears the coordinate system by `sh` horizontally and `sv` vertically, and returns a reference to the matrix.
`java.lang.String` | `toString()`
`QMatrix` | `translate(double dx, double dy)` Moves the coordinate system `dx` along the x axis and `dy` along the y axis, and returns a reference to the matrix.
`void` | `writeTo(QDataStream arg__1)` Writes thisQMatrix

Methods inherited from class com.trolltech.qt.QtJambiObject
`dispose, disposed, equals, finalize, reassignNativeResources, tr, tr, tr`

Methods inherited from class com.trolltech.qt.QSignalEmitter
`blockSignals, disconnect, disconnect, signalsBlocked, signalSender, thread`

Methods inherited from class com.trolltech.qt.internal.QSignalEmitterInternal
`__qt_signalInitialization`

Methods inherited from class java.lang.Object
`getClass, hashCode, notify, notifyAll, wait, wait, wait`

Methods inherited from interface com.trolltech.qt.QtJambiInterface
`disableGarbageCollection, nativeId, nativePointer, reenableGarbageCollection, setJavaOwnership`

Constructor Detail

### QMatrix

    public QMatrix()

  Constructs an identity matrix.

  All elements are set to zero except `m11` and `m22` (specifying the scale), which are set to 1.

See also:
  `reset()`.

### QMatrix

    public QMatrix(QMatrix matrix)

  Constructs a matrix that is a copy of the given `matrix`.

### QMatrix

    public QMatrix(double m11,
                   double m12,
                   double m21,
                   double m22,
                   double dx,
                   double dy)

  Constructs a matrix with the elements, `m11`, `m12`, `m21`, `m22`, `dx` and `dy`.

See also:
  `setMatrix()`.

Method Detail

### det

    public final double det()

  Returns the matrix's determinant.

### dx

    public final double dx()

  Returns the horizontal translation factor.

See also:
  `translate()`, and `Basic Matrix Operations`.

### dy

    public final double dy()

  Returns the vertical translation factor.

See also:
  `translate()`, and `Basic Matrix Operations`.

### isIdentity

    public final boolean isIdentity()

  Returns true if the matrix is the identity matrix, otherwise returns false.

See also:
  `reset()`.

### isInvertible

    public final boolean isInvertible()

  Returns true if the matrix is invertible, otherwise returns false.

See also:
  `inverted()`.

### m11

    public final double m11()

  Returns the horizontal scaling factor.

See also:
  `scale()`, and `Basic Matrix Operations`.

### m12

    public final double m12()

  Returns the vertical shearing factor.

See also:
  `shear()`, and `Basic Matrix Operations`.

### m21

    public final double m21()

  Returns the horizontal shearing factor.

See also:
  `shear()`, and `Basic Matrix Operations`.

### m22

    public final double m22()

  Returns the vertical scaling factor.

See also:
  `scale()`, and `Basic Matrix Operations`.

### map

    public final QLine map(QLine l)

  Creates and returns a `QLine` object that is a copy of the given `line`, mapped into the coordinate system defined by this matrix. Note that the transformed coordinates are rounded to the nearest integer.

### map

    public final QLineF map(QLineF l)

  Creates and returns a `QLineF` object that is a copy of the given `line`, mapped into the coordinate system defined by this matrix.

### map

    public final QPainterPath map(QPainterPath p)

  Creates and returns a `QPainterPath` object that is a copy of the given `path`, mapped into the coordinate system defined by this matrix.

### map

    public final QPoint map(QPoint p)

  Creates and returns a `QPoint` object that is a copy of the given `point`, mapped into the coordinate system defined by this matrix. Note that the transformed coordinates are rounded to the nearest integer.

### map

    public final QPointF map(QPointF p)

  Creates and returns a `QPointF` object that is a copy of the given `point`, mapped into the coordinate system defined by this matrix.

### map

    public final QPolygon map(QPolygon a)

  Creates and returns a `QPolygon` object that is a copy of the given `polygon`, mapped into the coordinate system defined by this matrix. Note that the transformed coordinates are rounded to the nearest integer.

### map

    public final QPolygonF map(QPolygonF a)

  Creates and returns a `QPolygonF` object that is a copy of the given `polygon`, mapped into the coordinate system defined by this matrix.

### map

    public final QRegion map(QRegion r)

  Creates and returns a `QRegion` object that is a copy of the given `region`, mapped into the coordinate system defined by this matrix.

  Calling this method can be rather expensive if rotations or shearing are used.

### mapRect

    public final QRect mapRect(QRect arg__1)

  Creates and returns a `QRect` object that is a copy of the given `rectangle`, mapped into the coordinate system defined by this matrix. Note that the transformed coordinates are rounded to the nearest integer.

### mapRect

    public final QRectF mapRect(QRectF arg__1)

  Creates and returns a `QRectF` object that is a copy of the given `rectangle`, mapped into the coordinate system defined by this matrix.

  The rectangle's coordinates are transformed using the following formulas:

              x' = m11 + m21 + dx
              y' = m22 + m12 + dy

  If rotation or shearing has been specified, this function returns the bounding rectangle. To retrieve the exact region the given `rectangle` maps to, use the `mapToPolygon()` function instead.

See also:
  `mapToPolygon()`, and `Basic Matrix Operations`.

### mapToPolygon

    public final QPolygon mapToPolygon(QRect r)

  Creates and returns a `QPolygon` representation of the given `rectangle`, mapped into the coordinate system defined by this matrix.

  The rectangle's coordinates are transformed using the following formulas:

              x' = m11 + m21 + dx
              y' = m22 + m12 + dy

  Polygons and rectangles behave slightly differently when transformed (due to integer rounding), so `matrix.map(QPolygon(rectangle))` is not always the same as `matrix.mapToPolygon(rectangle)`.

See also:
  `mapRect()`, and `Basic Matrix Operations`.

### writeTo

    public final void writeTo(QDataStream arg__1)

  Writes thisQMatrix

### readFrom

    public final void readFrom(QDataStream arg__1)

  Reads a QMatrix

### reset

    public final void reset()

  Resets the matrix to an identity matrix, i. . all elements are set to zero, except `m11` and `m22` (specifying the scale) which are set to 1.

See also:
  QMatrix(), `isIdentity()`, and `Basic Matrix Operations`.

### setMatrix

    public final void setMatrix(double m11,
                                double m12,
                                double m21,
                                double m22,
                                double dx,
                                double dy)

  Sets the matrix elements to the specified values, `m11`, `m12`, `m21`, `m22`, `dx` and `dy`.

  Note that this function replaces the previous values. `QMatrix` provide the `translate()`, `rotate()`, `scale()` and `shear()` convenience functions to manipulate the various matrix elements based on the currently defined coordinate system.

See also:
  QMatrix().

### rotate

    public final QMatrix rotate(double other)

  Rotates the coordinate system the given `other` degrees counterclockwise.

  Note that if you apply a QMatrix to a point defined in widget coordinates, the direction of the rotation will be clockwise because the y-axis points downwards.

  Returns a reference to the matrix.

### scale

    public final QMatrix scale(double sx,
                               double sy)

  Scales the coordinate system by `sx` horizontally and `sy` vertically, and returns a reference to the matrix.

### shear

    public final QMatrix shear(double sh,
                               double sv)

  Shears the coordinate system by `sh` horizontally and `sv` vertically, and returns a reference to the matrix.

### translate

    public final QMatrix translate(double dx,
                                   double dy)

  Moves the coordinate system `dx` along the x axis and `dy` along the y axis, and returns a reference to the matrix.

### inverted

    public final QMatrix inverted()

  Returns an inverted copy of this matrix.

  Returns:
    The inverse of the matrix.
  Throws:
    `java.lang.IllegalArgumentException` - If this matrix is not invertible.

### multiply

    public final QMatrix multiply(QMatrix other)

### multiplied

    public final QMatrix multiplied(QMatrix other)

### toString

    public java.lang.String toString()

  Overrides:
    `toString` in class `java.lang.Object`

### clone

    public QMatrix clone()

  Overrides:
    `clone` in class `java.lang.Object`

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD